DerethForever.Web/Controllers/RecipeController.cs
/*****************************************************************************************
Copyright 2018 Dereth Forever

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
*****************************************************************************************/
using System;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Web;
using System.Web.Mvc;

using log4net;
using Newtonsoft.Json;

using Lifestoned.DataModel.Gdle.Recipes;
using Lifestoned.DataModel.Shared;
using Lifestoned.Providers;

namespace DerethForever.Web.Controllers
{
    public class RecipeController : BaseController
    {
        private static readonly ILog log = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        private IRecipeProvider Provider => ContentProviderHost.GetProvider<IRecipeProvider>(RecipeChange.TypeName);

        private IRecipeSandboxProvider SandboxProvider => SandboxContentProviderHost.GetProvider<IRecipeSandboxProvider>(RecipeChange.TypeName);

        [HttpGet]
        public ActionResult Index()
        {
            return View(Provider.Get());
        }

        [HttpGet]
        public ActionResult Get(uint id, string userGuid)
        {
            Guid userId = Guid.Empty;

            if (User.Identity.IsAuthenticated)
            {
                if (!string.IsNullOrWhiteSpace(userGuid) && (userGuid == GetUserGuid() || User.IsInRole("Developer")))
                {
                    userId = new Guid(userGuid);
                }
                else
                {
                    userId = new Guid(GetUserGuid());
                }
            }

            ChangeEntry<Recipe> change = SandboxProvider.GetChange(userId, id);
            if (change != null)
                return JsonGet(change.Entry, true);

            Recipe model = Provider.Get(id);
            return JsonGet(model, true);
        }

        [HttpGet]
        public ActionResult Search(string name, uint? tool, uint? target, uint? result)
        {
            IQueryable<Recipe> model = null;
            if (User.Identity.IsAuthenticated)
            {
                model = SandboxProvider.Search(
                    new Guid(GetUserGuid()),
                    (r) => (!string.IsNullOrWhiteSpace(name) ? r.Description == name : true)
                        && (tool != null ? r.Precursors.Any(p => p.Tool == tool) : true)
                        && (target != null ? r.Precursors.Any(p => p.Target == target) : true)
                        && (result != null ? r.RecipeData.SuccessWcid == result : true));
            }
            else
            {
                model = Provider.Search((r) => (!string.IsNullOrWhiteSpace(name) ? r.Description == name : true)
                    && (tool != null ? r.Precursors.Any(p => p.Tool == tool) : true)
                    && (target != null ? r.Precursors.Any(p => p.Target == target) : true)
                    && (result != null ? r.RecipeData.SuccessWcid == result : true));
            }

            return JsonGet(model, true);
        }

        [HttpPut]
        [Authorize]
        public ActionResult Put([ModelBinder(typeof(JsonNetModelBinder))]Recipe model)
        {
            model.LastModified = DateTime.Now;
            model.ModifiedBy = GetUserName();

            Guid userId = new Guid(GetUserGuid());

            try
            {
                SandboxProvider.UpdateChange(userId, model);
                ////ContentProviderHost.CurrentRecipeProvider.Save(model);
                return new HttpStatusCodeResult(System.Net.HttpStatusCode.OK);
            }
            catch (Exception ex)
            {
                log.Error($"Error Saving Recipe {model.Key} - {model.Description}", ex);
            }

            return new HttpStatusCodeResult(System.Net.HttpStatusCode.InternalServerError, "Save Failed");
        }

        [HttpGet]
        public ActionResult Detail(uint id, string userGuid)
        {
            ViewBag.UserGuid = userGuid;
            return View(id);
        }

        [HttpGet]
        public ActionResult Edit(uint? id)
        {
            return View(id);
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public ActionResult Delete(uint id)
        {
            return View(Provider.Get(id));
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        public ActionResult Delete(Recipe model)
        {
            Provider.Delete(model.Key);
            return RedirectToAction("Index");
        }

        [HttpGet]
        [Authorize]
        public ActionResult Upload()
        {
            return View();
        }

        [HttpPost]
        [Authorize]
        public ActionResult UploadItem()
        {
            string fileNameCopy = "n/a";

            try
            {
                foreach (string fileName in Request.Files)
                {
                    fileNameCopy = fileName;
                    HttpPostedFileBase file = Request.Files[fileName];
                    uint id = 0;

                    using (MemoryStream memStream = new MemoryStream())
                    {
                        file.InputStream.CopyTo(memStream);
                        byte[] data = memStream.ToArray();

                        string serialized = Encoding.UTF8.GetString(data);
                        Recipe item = JsonConvert.DeserializeObject<Recipe>(serialized);
                        id = item.Key;

                        string token = GetUserToken();

                        item.LastModified = DateTime.Now;
                        item.ModifiedBy = GetUserName();

                        Guid userId = new Guid(GetUserGuid());

                        // save it
                        ////ContentProviderHost.CurrentRecipeProvider.Save(item);
                        SandboxProvider.UpdateChange(userId, item);
                    }
                }
            }
            catch (Exception ex)
            {
                log.Error($"Error parsing uploaded file {fileNameCopy}.", ex);
                return new HttpStatusCodeResult(System.Net.HttpStatusCode.BadRequest);
            }

            return new EmptyResult();
        }

        [HttpGet]
        public ActionResult DownloadOriginal(uint id)
        {
            try
            {
                Recipe model = Provider.Get(id);
                return DownloadJson(model, model.Key, model.Description);
            }
            catch (Exception ex)
            {
                log.Error($"Error exporting recipe {id}", ex);
                return RedirectToAction("Index");
            }
        }

        [HttpGet]
        [Authorize]
        public ActionResult DownloadSandbox(uint id, string userGuid)
        {
            Guid userId = Guid.Empty;

            if (User.Identity.IsAuthenticated)
            {
                if (!string.IsNullOrWhiteSpace(userGuid) && (userGuid == GetUserGuid() || User.IsInRole("Developer")))
                {
                    userId = new Guid(userGuid);
                }
                else
                {
                    userId = new Guid(GetUserGuid());
                }
            }

            try
            {
                ChangeEntry<Recipe> change = SandboxProvider.GetChange(userId, id);
                if (change == null)
                {
                    return HttpNotFound();
                }

                return DownloadJson(change.Entry, change.EntryId, change.Entry.Description);
            }
            catch (Exception ex)
            {
                log.Error($"Error exporting recipe {id}", ex);
                return new HttpStatusCodeResult(HttpStatusCode.InternalServerError);
            }
        }
    }
}

DerethForever.Web/Controllers/SpawnController.cs
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Mvc;
using Lifestoned.DataModel.Gdle.Spawns;
using Lifestoned.Providers;
using log4net;
using Newtonsoft.Json;

namespace DerethForever.Web.Controllers
{
    public class SpawnController : BaseController
    {
        private static readonly ILog log = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        private ISpawnMapProvider Provider => ContentProviderHost.GetProvider<ISpawnMapProvider>(SpawnMapChange.TypeName);

        private ISpawnMapSandboxProvider SandboxProvider => SandboxContentProviderHost.GetProvider<ISpawnMapSandboxProvider>(SpawnMapChange.TypeName);

        // GET: Spawn
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult Map(uint id)
        {
            SpawnMapEntry result = null;
            if (User.Identity.IsAuthenticated)
            {
                SpawnMapChange change = SandboxProvider.GetChange(new Guid(GetUserGuid()), id) as SpawnMapChange;
                result = change?.Entry;
            }

            if (result == null)
                result = Provider.Get(id);

            return JsonGet(result);
            ////SpawnMapChange change = SandboxContentProviderHost.CurrentProvider.GetLandblockChange(id);
            ////if (change != null)
            ////    return JsonGet(change.Entry);
            ////return JsonGet(SandboxContentProviderHost.CurrentProvider.GetLandblock(id));
        }

        public ActionResult Search(string query)
        {
            if (User.Identity.IsAuthenticated)
            {
                return JsonGet(SandboxProvider.Search(new Guid(GetUserGuid()), s => s.Description == query));
            }
            else
            {
                return JsonGet(Provider.Search(s => s.Description == query));
            }
            ////return JsonGet(SandboxContentProviderHost.CurrentProvider.SearchLandblocks(query));
        }

        [Authorize]
        [HttpPost]
        public ActionResult New(SpawnMapEntry map)
        {
            map.LastModified = DateTime.Now;
            map.ModifiedBy = GetUserName();
            Guid uid = new Guid(GetUserGuid());

            if (SandboxProvider.GetChange(uid, map.Key) != null)
                return Json(null);

            SandboxProvider.UpdateChange(uid, map);
            return Json(map);

            ////if (SandboxContentProviderHost.CurrentProvider.GetLandblock(map.Key) != null)
            ////    return Json(null);

            ////SandboxContentProviderHost.CurrentProvider.SaveLandblock(map);
            ////return Json(map);
        }

        [Authorize]
        [HttpPost]
        public ActionResult Save(SpawnMapEntry map)
        {
            map.LastModified = DateTime.Now;
            map.ModifiedBy = GetUserName();

            SandboxProvider.UpdateChange(new Guid(GetUserGuid()), map);
            ////SandboxContentProviderHost.CurrentProvider.SaveLandblock(map);
            return RedirectToAction("Index", "Sandbox");
        }

        [HttpGet]
        public ActionResult Download(uint id, string userGuid = null)
        {
            SpawnMapEntry map = null;

            if (!string.IsNullOrWhiteSpace(userGuid))
            {
                // id specified: is it us, or are we an admin
                if (string.Compare(userGuid, GetUserGuid(), true) == 0 || User.IsInRole("Developer"))
                {
                    SpawnMapChange change = SandboxProvider.GetChange(new Guid(GetUserGuid()), id) as SpawnMapChange;
                    ////SpawnMapChange change = SandboxContentProviderHost.CurrentProvider.GetLandblockChange(id, userGuid);
                    map = change.Entry;
                }
            }
            else
            {
                map = Provider.Get(id);
                ////map = ContentProviderHost.CurrentProvider.GetLandblock(id);
            }

            if (map == null)
                return new HttpNotFoundResult();

            JsonSerializerSettings s = new JsonSerializerSettings { NullValueHandling = NullValueHandling.Ignore };
            string content = JsonConvert.SerializeObject(map, Formatting.None, s);
            string name = map.Description;
            foreach (char ifn in System.IO.Path.GetInvalidFileNameChars())
                name = name.Replace(ifn, '_');

            string filename = $"{name}.json";
            return File(Encoding.UTF8.GetBytes(content), "application/json", filename);
        }

        [HttpGet]
        [Authorize]
        public ActionResult Upload()
        {
            return View();
        }

        [HttpPost]
        [Authorize]
        public ActionResult UploadItem()
        {
            string fileNameCopy = "n/a";

            try
            {
                Guid uid = new Guid(GetUserGuid());

                foreach (string fileName in Request.Files)
                {
                    fileNameCopy = fileName;
                    HttpPostedFileBase file = Request.Files[fileName];
                    uint id = 0;

                    using (MemoryStream memStream = new MemoryStream())
                    {
                        file.InputStream.CopyTo(memStream);
                        byte[] data = memStream.ToArray();

                        string serialized = Encoding.UTF8.GetString(data);
                        SpawnMapEntry item = JsonConvert.DeserializeObject<SpawnMapEntry>(serialized);
                        id = item.Key;

                        ////string token = GetUserToken();

                        item.LastModified = DateTime.Now;
                        item.ModifiedBy = GetUserName();

                        // save it
                        SandboxProvider.UpdateChange(uid, item);
                        ////SandboxContentProviderHost.CurrentProvider.SaveLandblock(item);
                    }
                }
            }
            catch (Exception ex)
            {
                log.Error($"Error parsing uploaded file {fileNameCopy}.", ex);
                return new HttpStatusCodeResult(System.Net.HttpStatusCode.BadRequest);
            }

            return new EmptyResult();
        }

        [Authorize(Roles = "Developer")]
        [HttpGet]
        public ActionResult Compile()
        {
            SpawnMap map = new SpawnMap();

            ////foreach (SpawnMapEntry entry in ContentProviderHost.CurrentProvider.GetLandblocks())
            foreach (SpawnMapEntry entry in Provider.Get())
            {
                map.Entries.Add(entry);
            }

            string now = DateTime.UtcNow.ToString();
            map.Comment = $"Created by {GetUserName()} at {now}";

            JsonSerializerSettings s = new JsonSerializerSettings { NullValueHandling = NullValueHandling.Ignore };
            string content = JsonConvert.SerializeObject(map, Formatting.None, s);

            string name = $"worldspawns-{now}";
            foreach (char ifn in System.IO.Path.GetInvalidFileNameChars())
                name = name.Replace(ifn, '_');

            string filename = $"{name}.json";
            return File(Encoding.UTF8.GetBytes(content), "application/json", filename);
        }
    }
}

DerethForever.Web/Views/Shared/DisplayTemplates/ChangeDiscussionEntry.cshtml
@model Lifestoned.DataModel.Shared.ChangeDiscussionEntry

<div class="panel panel-default">
    <div class="panel-heading">
        @Html.Raw(Html.Encode(Model.UserName + " on " + Model.Created.ToString("g")))
    </div>
    <div class="panel-body text-prewrap">@Html.Raw(Html.Encode(Model.Comment))</div>
</div>

DerethForever.Web/Views/Shared/DisplayTemplates/ChangeDiscussionList.cshtml
@model List<Lifestoned.DataModel.Shared.ChangeDiscussionEntry>

<div class="panel panel-default">
    <div class="panel-heading">
        <a href="#@(Html.IdFor(m => m))" data-toggle="collapse" aria-expanded="false">Discussion</a>
    </div>
    <div id="@(Html.IdFor(m => m))" class="panel-collapse collapse panel-body">
        <div class="panel-group">
            @for (int i = 0; i < Model.Count(); i++)
            {
                @Html.DisplayFor(m => Model[i])
            }

            @if ((Model?.Count() ?? 0) == 0)
            {
                <p>No comments.</p>
            }
        </div>
        <div class="col-sm-10">
            <button type="button" class="btn btn-primary"
                    data-toggle="modal" data-target="#modal-discussion"
                    data-user="@(ViewData["UserGuid"])" data-item="@(ViewData["EntryId"])" data-type="@(ViewData["EntryType"])">
                Add Comment
            </button>
        </div>

    </div>

</div>

DerethForever.Web/Views/Shared/DisplayTemplates/ChangeEntries.cshtml
@model List<Lifestoned.DataModel.Shared.ChangeEntry>

@if (Model == null || Model.Count() < 1)
{
    <div class="alert alert-info">
        There are no changes to review.
    </div>
}
else
{
    <div class="entries">
        @{
            for (int i = 0; i < Model.Count(); i++)
            {
                @Html.DisplayFor(m => Model[i]);
            }
        }

    </div>

}

DerethForever.Web/Views/Shared/DisplayTemplates/Changelog.cshtml
@model List<Lifestoned.DataModel.Shared.ChangelogEntry>

@for (int i = 0; i < (Model?.Count ?? 0); i++)
{
    @Html.HiddenFor(m => m[i].Created)
    @Html.HiddenFor(m => m[i].Author)
    @Html.HiddenFor(m => m[i].Comment)
    <div class="row row-spacer">
        <div class="col-md-10">
            <div class="panel panel-default">
                <div class="panel-heading">
                    @Html.Raw(Html.Encode(Model[i].Author + " on " + Model[i].Created.ToString("g")))
                </div>
                <div class="panel-body text-prewrap">
                    @Html.Raw(Html.Encode(Model[i].Comment))
                </div>
            </div>
        </div>
    </div>
}

DerethForever.Web/Views/Shared/DisplayTemplates/DateTime.cshtml
@model System.DateTime?

@if (Model != null)
{
    <span>@Html.Raw(Model.Value.ToString("yyyy-MM-dd HH:mm"))</span>
}

DerethForever.Web/Views/Shared/DisplayTemplates/InfoMessages.cshtml
@model Lifestoned.DataModel.Shared.BaseModel

@if (Model?.ErrorMessages?.Count > 0)
{
    <div class="alert alert-danger">
        <ul>
            @for (int i = 0; i < Model.ErrorMessages.Count; i++)
            {
                <li>@Html.DisplayFor(m => m.ErrorMessages[i])</li>
            }
        </ul>
        @if (Model.Exception != null)
        {
            <pre>@Html.DisplayFor(m => m.Exception)</pre>
        }
    </div>
}

@if (Model?.InfoMessages?.Count > 0)
{
    <div class="alert alert-info">
        <ul>
            @for (int i = 0; i < Model.InfoMessages.Count; i++)
            {
                <li>@Html.DisplayFor(m => m.InfoMessages[i])</li>
            }
        </ul>
    </div>
    <hr />
}

@if (Model?.SuccessMessages?.Count > 0)
{
    <div class="alert alert-success">
        <ul>
            @for (int i = 0; i < Model.SuccessMessages.Count; i++)
            {
                <li>@Html.DisplayFor(m => m.SuccessMessages[i])</li>
            }
        </ul>
    </div>
    <hr />
}

@if (Model?.WarningMessages?.Count > 0)
{
    <div class="alert alert-warning">
        <ul>
            @for (int i = 0; i < Model.WarningMessages.Count; i++)
            {
                <li>@Html.DisplayFor(m => m.WarningMessages[i])</li>
            }
        </ul>
    </div>
    <hr />
}

DerethForever.Web/Views/Shared/DisplayTemplates/RecipeChange.cshtml
@model Lifestoned.DataModel.Gdle.Recipes.RecipeChange
@using DerethForever.Web.Controllers

@{
    bool IsApproval = ViewData.Where(kv => kv.Key == "IsApproval").FirstOrDefault().Value as bool? ?? false;
}

<div class="well @(!Model.Submitted ? "need-submit" : "submitted")"
     data-id="@(Model.EntryId)"
     data-type="@(Model.EntryType)"
     data-name="@(Model.Entry.Description)"
     data-user="@(Model.UserName)"
     data-date="@(new DateTimeOffset(Model.SubmissionTime.ToUniversalTime()).ToUnixTimeSeconds())">
    <div class="row">
        <div class="col-md-1">
            <div class="icon">
                <img src="@Url.Action("GetImage", "Resource",
                            new { imageId = 0x06001AA4 }) " />
            </div>
        </div>
        <div class="col-md-6">
            <a href="@Url.Action("Detail", "Recipe", new { id = Model.EntryId, userGuid = Model.UserGuid })">
                @Html.DisplayFor(m => m.Entry.Description)
                (@Html.DisplayFor(m => m.EntryId))</a><br />
            Submitted by @Html.DisplayFor(m => m.UserName) on @Html.DisplayFor(m => m.SubmissionTimeDisplay)<br />
            <br />
        </div>
        <div class="col-md-5">
            <div class="btn-group">
                @if (!IsApproval)
                {
                    <div class="btn btn-default btn-sm">@Html.ActionLink("Edit", "Edit", "Recipe", new { id = Model.EntryId }, null)</div>
                }
                <div class="btn btn-default btn-sm">
                    <i class="glyphicon glyphicon-download"></i>
                    @Html.ActionLink("Sandbox", "DownloadSandbox", "Recipe", new { id = Model.EntryId, userGuid = Model.UserGuid }, null)
                </div>
                <div class="btn btn-default btn-sm">
                    <i class="glyphicon glyphicon-download"></i>
                    @Html.ActionLink("Original", "DownloadOriginal", "Recipe", new { id = Model.EntryId }, null)
                </div>

            </div>
            @if (!IsApproval && BaseController.CurrentUser.AccountGuid == Model.UserGuid)
            {
                <div>
                    @if (Model.Submitted)
                    {
                        <button data-id="@(Model.EntryId)" data-type="@(Model.EntryType)" class="sandbox-submit btn btn-sm btn-primary">Withdraw Submission</button>
                    }
                    else
                    {
                        <button data-id="@(Model.EntryId)" data-type="@(Model.EntryType)" class="sandbox-submit btn btn-sm btn-warning">Submit for Review</button>
                    }
                    <button data-id="@(Model.EntryId)" data-type="@(Model.EntryType)" class="sandbox-delete btn btn-sm btn-danger"><span class="glyphicon glyphicon-trash"></span></button>
                </div>
            }
            @if (IsApproval && User.IsInRole("Developer"))
            {
                <div>
                    <button class="btn btn-sm btn-warning"
                            data-toggle="modal" data-target="#modal-reject"
                            data-user="@(Model.UserGuid)" data-id="@(Model.EntryId)" data-type="@(Model.EntryType)">
                        Reject
                    </button>

                    <button class="sandbox-approve btn btn-sm btn-primary"
                            data-id="@(Model.EntryId)"
                            data-type="@(Model.EntryType)"
                            data-user="@(Model.UserGuid)"
                            data-done="0">
                        Accept
                    </button>

                    <button class="sandbox-approve btn btn-sm btn-primary"
                            data-id="@(Model.EntryId)"
                            data-type="@(Model.EntryType)"
                            data-user="@(Model.UserGuid)"
                            data-done="1">
                        Final Accept
                    </button>
                </div>
            }

        </div>
    </div>
    <br />

    <div class="panel panel-default">
        <div class="panel-heading">
            <a href="#@(Html.IdFor(m => m))" data-toggle="collapse" aria-expanded="false">Change Log Entry</a>
        </div>
        <div id="@(Html.IdFor(m => m))" class="panel-collapse collapse panel-body">
            @Html.Raw(string.IsNullOrEmpty(Model.Entry.UserChangeSummary) ? "None" : Model.Entry.UserChangeSummary)
        </div>

    </div>

    @Html.DisplayFor(m => m.Discussion, new {
        UserGuid = Model.UserGuid,
        EntryId = Model.EntryId,
        EntryType = "recipe" })

</div>

DerethForever.Web/Views/Shared/DisplayTemplates/SpawnMapChange.cshtml
@model Lifestoned.DataModel.Gdle.Spawns.SpawnMapChange
@using DerethForever.Web.Controllers

@{ 
    bool IsApproval = ViewData.Where(kv => kv.Key == "IsApproval").FirstOrDefault().Value as bool? ?? false;
}

<div class="well @(!Model.Submitted ? "need-submit" : "submitted")"
     data-id="@(Model.EntryId)"
     data-type="@(Model.EntryType)"
     data-name="@(Model.Entry.Description)"
     data-user="@(Model.UserName)"
     data-date="@(new DateTimeOffset(Model.SubmissionTime.ToUniversalTime()).ToUnixTimeSeconds())">
    <div class="row">
        <div class="col-md-1">
            <div class="icon">
                <img src="@Url.Action("GetImage", "Resource",
                            new { imageId = 0x0600211F }) " />
            </div>
        </div>
        <div class="col-md-6">
            @Html.DisplayFor(m => m.Entry.Description)
            (@Html.DisplayFor(m => m.EntryId))<br />
            Submitted by @Html.DisplayFor(m => m.UserName) on @Html.DisplayFor(m => m.SubmissionTimeDisplay)<br />
            <br />
        </div>
        <div class="col-md-5">
            <div class="btn-group">
                @if (!IsApproval)
                {
                    <button type="button" class="btn btn-default btn-sm" @@click="editMap(@Model.Entry.Key)">Edit</button>
                    <div class="btn btn-default btn-sm">@Html.ActionLink("Clone", "Clone", "Spawns", new { id = Model.Entry.Key }, null)</div>
                }
                <div class="btn btn-default btn-sm">
                    <i class="glyphicon glyphicon-download"></i>
                    @Html.ActionLink("Sandbox", "Download", "Spawn", new { id = Model.Entry.Key, userGuid = Model.UserGuid }, null)
                </div>
                <div class="btn btn-default btn-sm">
                    <i class="glyphicon glyphicon-download"></i>
                    @Html.ActionLink("Original", "Download", "Spawn", new { id = Model.Entry.Key }, null)
                </div>

            </div>
            @if (!IsApproval && BaseController.CurrentUser.AccountGuid == Model.UserGuid)
            {
                <div>
                    @if (Model.Submitted)
                    {
                        <button data-id="@(Model.EntryId)" data-type="@(Model.EntryType)" class="sandbox-submit btn btn-sm btn-primary">Withdraw Submission</button>
                    }
                    else
                    {
                        <button data-id="@(Model.EntryId)" data-type="@(Model.EntryType)" class="sandbox-submit btn btn-sm btn-warning">Submit for Review</button>
                    }
                    <button data-id="@(Model.EntryId)" data-type="@(Model.EntryType)" class="sandbox-delete btn btn-sm btn-danger"><span class="glyphicon glyphicon-trash"></span></button>
                </div>
            }
            @if (IsApproval && User.IsInRole("Developer"))
            {
                <div>
                    <button class="btn btn-sm btn-warning"
                            data-toggle="modal" data-target="#modal-reject"
                            data-user="@(Model.UserGuid)" data-id="@(Model.EntryId)" data-type="@(Model.EntryType)">
                        Reject
                    </button>

                    <button class="sandbox-approve btn btn-sm btn-primary"
                            data-id="@(Model.EntryId)"
                            data-type="@(Model.EntryType)"
                            data-user="@(Model.UserGuid)"
                            data-done="0">
                        Accept
                    </button>

                    <button class="sandbox-approve btn btn-sm btn-primary"
                            data-id="@(Model.EntryId)"
                            data-type="@(Model.EntryType)"
                            data-user="@(Model.UserGuid)"
                            data-done="1">
                        Final Accept
                    </button>
                </div>
            }

        </div>
    </div>
    <br />

    <div class="panel panel-default">
        <div class="panel-heading">
            <a href="#@(Html.IdFor(m => m))" data-toggle="collapse" aria-expanded="false">Change Log Entry</a>
        </div>
        <div id="@(Html.IdFor(m => m))" class="panel-collapse collapse panel-body">
            @Html.Raw(string.IsNullOrEmpty(Model.ChangeLog.UserChangeSummary) ? "None" : Model.ChangeLog.UserChangeSummary)
        </div>

    </div>

    @Html.DisplayFor(m => m.Discussion, new {
        UserGuid = Model.UserGuid,
        EntryId = Model.Entry.Key,
        EntryType = "spawnMap" })

</div>